import { Observable } from 'rxjs';

export interface NativeService {
  showNotify(
    roomSeq: number,
    title: string,
    contents: string,
    image: string,
    useSound: boolean
  ): void;

  checkForUpdates(): Observable<boolean>;

  showImageViewer(): void;

  saveFile(blob: Blob): void;
}
